package com.caimei.service;

import com.caimei.model.ResponseJson;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * Description
 *
 * @author : Charles
 * @date : 2020/3/21
 */
public interface OrderSubmitService {
    /**
     * 商品结算
     *
     * @param productIds 商品ID串用逗号隔开。
     * @param userId     机构用户id。
     * @return
     */
    ResponseJson<Map<String, Object>> orderConfirm(String productIds, Integer userId);

    /**
     * 提交订单
     *
     * @param clubUserId
     * @param addressId
     * @param orderInfo
     * @param payInfo
     * @param orderInvoice
     * @return
     */
    ResponseJson<Map<String, String>> orderSubmit(Integer clubUserId, Integer addressId, List<Map<String, Object>> orderInfo, Map<String, Object> payInfo, Map<String, Object> orderInvoice);

    /**
     * 订单余额抵扣
     * @param orderId 订单id
     * @return
     */
    ResponseJson<Map<String, Object>> balanceDeduction(Integer orderId);

    /**
     * 保存余额抵扣记录
     * @param balancePayFee 余额支付金额
     * @param orderId       订单id
     * @param userId        用户id
     */
    void saveBalanceRecord(BigDecimal balancePayFee, Integer orderId, Integer userId);

    /**
     * 保存收款记录
     * @param balancePayFee 余额支付金额
     * @param orderId       订单id
     */
    void saveDiscernReceipt(BigDecimal balancePayFee, Integer orderId);
}
